#include <stdio.h>
#include <stdlib.h>

#include "AWList.h"

static inline void mfree(void* arg) {
  free(arg);
  arg = NULL;
}

int main() {
  AWList list = {0};
  AWList_init(&list);

  int* num[10] = {NULL};
  for (int i = 0; i < 10; ++i) {
    num[i]  = calloc(1, sizeof(int));
    *num[i] = i;

    AWList_add_tail(&list, num[i], mfree);
  }

  AWNode* node = NULL;
  for (node = list.head->next; node != list.tail->next; node = node->next) {
    printf("%d ", *(int*)node->data);
  }
  printf("\n");

  AWList_clear(&list);
  /* while ((node = AWList_iterator(&list))) { printf("%d ", *(int*)node->data); } */
  /* printf("\n"); */

  AWList_destroy(&list);
}
